progname=exercise_02_17

CFLAGS=-Wall -g
$(CXX)=g++

.SECONDARY:
.SUFFIXES:

$(progname): exercise_02_17.o
	@echo "Linking..."
	@$(CXX) $^ -o $@
%.o: %.s
	@echo "Compiling $< ..."
	@$(CXX) $(CFLAGS) -c $< -o $@

%.s: %.ii
	@echo "Assembling $< ..."
	@$(CXX) -S $< -o $@

%.ii: %.cpp
	@echo "Pre-processing $< ..."
	@$(CXX) -E $< -o $@
	@echo exercise_02_17 > .gitignore
clear:
	@echo "Cleaning ..."
	@rm $(progname) *.o *.s *.ii .gitignore .makefile.swo .makefile.swp

test:
	@./$(progname)
